<script setup lang="ts">
import type { IconValue } from "~/iconsets";

type CirclePath = {
  cx: number; cy: number; r: number; transform?: string;
};

const props = defineProps<{
  tag: string;
  icon?: IconValue;
  disabled?: boolean;
}>();

const extractCircle = (path: string): CirclePath | string => {
  if (!path.startsWith(":circle:") && !path.startsWith("M:circle:")) return path.startsWith("M") ? path : `M${path}`;

  const properties = path.replace("M:circle:", "").replace(":circle:", "")
    .split(",").map(prop => isNaN(+(prop.trim())) ? prop.trim() : +(prop.trim())
    );

  return ({
    cx: (properties[0]) as number ?? 0, cy: properties[1] as number ?? 0, r: properties[2] as number ?? 0,
    transform: properties[3] as string ?? null
  });
};

const paths = computed(() => props.icon?.toString().split(" M").map((path) =>
  extractCircle(path)
));
</script>

<template>
  <component v-bind="$attrs" :is="tag" :style="null">
    <svg
      xmlns="http://www.w3.org/2000/svg"
      viewBox="0 0 24 24"
      role="img"
      aria-hidden="true"
      fill="none"
      class="v-icon__svg"
    >
      <template v-for="path in paths" :key="path">
        <path
          v-if="typeof path === 'string'"
          :d="path" stroke="currentColor" stroke-width="1.5" stroke-linecap="round"
          stroke-linejoin="round"
        />
        <circle
          v-else :cx="path.cx" :cy="path.cy" :r="path.r"
          :transform="path.transform" stroke="currentColor" stroke-width="1.5" stroke-linecap="round"
        />
      </template>
    </svg>
  </component>
</template>
